# ce_command – Run arbitrary command on HUAWEI CloudEngine devices

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Sends an arbitrary command to an HUAWEI CloudEngine node and returns the results read from the device. The ce_command module includes an argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
commands - / required |  | The commands to send to the remote HUAWEI CloudEngine device over the configured provider. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retries has been exceeded.
interval - | Default: 1 | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditional, the interval indicates how to long to wait before trying the command again.
match - | Default: "all" | The match argument is used in conjunction with the wait_for argument to specify the match policy. Valid values are `all` or `any`. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.
retries - | Default: 10 | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditionals.
wait_for - |  | Specifies what to evaluate from the output of the command and what conditionals to apply. This argument will cause the task to wait for a particular conditional to be true before moving forward. If the conditional is not true by the configured retries, the task fails. See examples.

## Notes

Note

- Recommended connection is `network_cli`.

- This module also works with `local` connections for legacy playbooks.

## Examples

    # Note: examples below use the following provider dict to handle
    #       transport and authentication to the node.

    - name: CloudEngine command test
      hosts: cloudengine
      connection: local
      gather_facts: no
      vars:
        cli:
          host: "{{ inventory_hostname }}"
          port: "{{ ansible_ssh_port }}"
          username: "{{ username }}"
          password: "{{ password }}"
          transport: cli

      tasks:
      - name: "Run display version on remote devices"
        ce_command:
          commands: display version
          provider: "{{ cli }}"

      - name: "Run display version and check to see if output contains HUAWEI"
        ce_command:
          commands: display version
          wait_for: result[0] contains HUAWEI
          provider: "{{ cli }}"

      - name: "Run multiple commands on remote nodes"
        ce_command:
          commands:
            - display version
            - display device
          provider: "{{ cli }}"

      - name: "Run multiple commands and evaluate the output"
        ce_command:
          commands:
            - display version
            - display device
          wait_for:
            - result[0] contains HUAWEI
            - result[1] contains Device
          provider: "{{ cli }}"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
failed_conditions list | failed | the conditionals that failed Sample: ['...', '...']
stdout list | always | the set of responses from the commands Sample: ['...', '...']
stdout_lines list | always | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- JackyGao2016 (@CloudEngine-Ansible)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.